<?php


abstract class BaseTercerosPeer {

	
	const DATABASE_NAME = 'propel';

	
	const TABLE_NAME = 'TERCEROS';

	
	const CLASS_DEFAULT = 'lib.model.Terceros';

	
	const NUM_COLUMNS = 12;

	
	const NUM_LAZY_LOAD_COLUMNS = 0;


	
	const NITOCC = 'TERCEROS.NITOCC';

	
	const TIPTER = 'TERCEROS.TIPTER';

	
	const RAZSOC = 'TERCEROS.RAZSOC';

	
	const CIUDAD = 'TERCEROS.CIUDAD';

	
	const TELEFO = 'TERCEROS.TELEFO';

	
	const TELFAX = 'TERCEROS.TELFAX';

	
	const DIRECC = 'TERCEROS.DIRECC';

	
	const ESTADO = 'TERCEROS.ESTADO';

	
	const EMAIL = 'TERCEROS.EMAIL';

	
	const SUELDO = 'TERCEROS.SUELDO';

	
	const CARGO = 'TERCEROS.CARGO';

	
	const CODREG = 'TERCEROS.CODREG';

	
	private static $phpNameMap = null;


	
	private static $fieldNames = array (
		BasePeer::TYPE_PHPNAME => array ('Nitocc', 'Tipter', 'Razsoc', 'Ciudad', 'Telefo', 'Telfax', 'Direcc', 'Estado', 'Email', 'Sueldo', 'Cargo', 'Codreg', ),
		BasePeer::TYPE_COLNAME => array (TercerosPeer::NITOCC, TercerosPeer::TIPTER, TercerosPeer::RAZSOC, TercerosPeer::CIUDAD, TercerosPeer::TELEFO, TercerosPeer::TELFAX, TercerosPeer::DIRECC, TercerosPeer::ESTADO, TercerosPeer::EMAIL, TercerosPeer::SUELDO, TercerosPeer::CARGO, TercerosPeer::CODREG, ),
		BasePeer::TYPE_FIELDNAME => array ('NITOCC', 'TIPTER', 'RAZSOC', 'CIUDAD', 'TELEFO', 'TELFAX', 'DIRECC', 'ESTADO', 'EMAIL', 'SUELDO', 'CARGO', 'CODREG', ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, )
	);

	
	private static $fieldKeys = array (
		BasePeer::TYPE_PHPNAME => array ('Nitocc' => 0, 'Tipter' => 1, 'Razsoc' => 2, 'Ciudad' => 3, 'Telefo' => 4, 'Telfax' => 5, 'Direcc' => 6, 'Estado' => 7, 'Email' => 8, 'Sueldo' => 9, 'Cargo' => 10, 'Codreg' => 11, ),
		BasePeer::TYPE_COLNAME => array (TercerosPeer::NITOCC => 0, TercerosPeer::TIPTER => 1, TercerosPeer::RAZSOC => 2, TercerosPeer::CIUDAD => 3, TercerosPeer::TELEFO => 4, TercerosPeer::TELFAX => 5, TercerosPeer::DIRECC => 6, TercerosPeer::ESTADO => 7, TercerosPeer::EMAIL => 8, TercerosPeer::SUELDO => 9, TercerosPeer::CARGO => 10, TercerosPeer::CODREG => 11, ),
		BasePeer::TYPE_FIELDNAME => array ('NITOCC' => 0, 'TIPTER' => 1, 'RAZSOC' => 2, 'CIUDAD' => 3, 'TELEFO' => 4, 'TELFAX' => 5, 'DIRECC' => 6, 'ESTADO' => 7, 'EMAIL' => 8, 'SUELDO' => 9, 'CARGO' => 10, 'CODREG' => 11, ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, )
	);

	
	public static function getMapBuilder()
	{
		return BasePeer::getMapBuilder('lib.model.map.TercerosMapBuilder');
	}
	
	public static function getPhpNameMap()
	{
		if (self::$phpNameMap === null) {
			$map = TercerosPeer::getTableMap();
			$columns = $map->getColumns();
			$nameMap = array();
			foreach ($columns as $column) {
				$nameMap[$column->getPhpName()] = $column->getColumnName();
			}
			self::$phpNameMap = $nameMap;
		}
		return self::$phpNameMap;
	}
	
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = isset(self::$fieldKeys[$fromType][$name]) ? self::$fieldKeys[$fromType][$name] : null;
		if ($key === null) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(self::$fieldKeys[$fromType], true));
		}
		return $toNames[$key];
	}

	

	static public function getFieldNames($type = BasePeer::TYPE_PHPNAME)
	{
		if (!array_key_exists($type, self::$fieldNames)) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	
	public static function alias($alias, $column)
	{
		return str_replace(TercerosPeer::TABLE_NAME.'.', $alias.'.', $column);
	}

	
	public static function addSelectColumns(Criteria $criteria)
	{

		$criteria->addSelectColumn(TercerosPeer::NITOCC);

		$criteria->addSelectColumn(TercerosPeer::TIPTER);

		$criteria->addSelectColumn(TercerosPeer::RAZSOC);

		$criteria->addSelectColumn(TercerosPeer::CIUDAD);

		$criteria->addSelectColumn(TercerosPeer::TELEFO);

		$criteria->addSelectColumn(TercerosPeer::TELFAX);

		$criteria->addSelectColumn(TercerosPeer::DIRECC);

		$criteria->addSelectColumn(TercerosPeer::ESTADO);

		$criteria->addSelectColumn(TercerosPeer::EMAIL);

		$criteria->addSelectColumn(TercerosPeer::SUELDO);

		$criteria->addSelectColumn(TercerosPeer::CARGO);

		$criteria->addSelectColumn(TercerosPeer::CODREG);

	}

	const COUNT = 'COUNT(TERCEROS.NITOCC)';
	const COUNT_DISTINCT = 'COUNT(DISTINCT TERCEROS.NITOCC)';

	
	public static function doCount(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(TercerosPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(TercerosPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$rs = TercerosPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}
	
	public static function doSelectOne(Criteria $criteria, $con = null)
	{
		$critcopy = clone $criteria;
		$critcopy->setLimit(1);
		$objects = TercerosPeer::doSelect($critcopy, $con);
		if ($objects) {
			return $objects[0];
		}
		return null;
	}
	
	public static function doSelect(Criteria $criteria, $con = null)
	{
		return TercerosPeer::populateObjects(TercerosPeer::doSelectRS($criteria, $con));
	}
	
	public static function doSelectRS(Criteria $criteria, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if (!$criteria->getSelectColumns()) {
			$criteria = clone $criteria;
			TercerosPeer::addSelectColumns($criteria);
		}

				$criteria->setDbName(self::DATABASE_NAME);

						return BasePeer::doSelect($criteria, $con);
	}
	
	public static function populateObjects(ResultSet $rs)
	{
		$results = array();
	
				$cls = TercerosPeer::getOMClass();
		$cls = sfPropel::import($cls);
				while($rs->next()) {
		
			$obj = new $cls();
			$obj->hydrate($rs);
			$results[] = $obj;
			
		}
		return $results;
	}

  static public function getUniqueColumnNames()
  {
    return array();
  }
	
	public static function getTableMap()
	{
		return Propel::getDatabaseMap(self::DATABASE_NAME)->getTable(self::TABLE_NAME);
	}

	
	public static function getOMClass()
	{
		return TercerosPeer::CLASS_DEFAULT;
	}

	
	public static function doInsert($values, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} else {
			$criteria = $values->buildCriteria(); 		}


				$criteria->setDbName(self::DATABASE_NAME);

		try {
									$con->begin();
			$pk = BasePeer::doInsert($criteria, $con);
			$con->commit();
		} catch(PropelException $e) {
			$con->rollback();
			throw $e;
		}

		return $pk;
	}

	
	public static function doUpdate($values, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$selectCriteria = new Criteria(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = clone $values; 
			$comparison = $criteria->getComparison(TercerosPeer::NITOCC);
			$selectCriteria->add(TercerosPeer::NITOCC, $criteria->remove(TercerosPeer::NITOCC), $comparison);

		} else { 			$criteria = $values->buildCriteria(); 			$selectCriteria = $values->buildPkeyCriteria(); 		}

				$criteria->setDbName(self::DATABASE_NAME);

		return BasePeer::doUpdate($selectCriteria, $criteria, $con);
	}

	
	public static function doDeleteAll($con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		$affectedRows = 0; 		try {
									$con->begin();
			$affectedRows += BasePeer::doDeleteAll(TercerosPeer::TABLE_NAME, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	 public static function doDelete($values, $con = null)
	 {
		if ($con === null) {
			$con = Propel::getConnection(TercerosPeer::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} elseif ($values instanceof Terceros) {

			$criteria = $values->buildPkeyCriteria();
		} else {
						$criteria = new Criteria(self::DATABASE_NAME);
			$criteria->add(TercerosPeer::NITOCC, (array) $values, Criteria::IN);
		}

				$criteria->setDbName(self::DATABASE_NAME);

		$affectedRows = 0; 
		try {
									$con->begin();
			
			$affectedRows += BasePeer::doDelete($criteria, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public static function doValidate(Terceros $obj, $cols = null)
	{
		$columns = array();

		if ($cols) {
			$dbMap = Propel::getDatabaseMap(TercerosPeer::DATABASE_NAME);
			$tableMap = $dbMap->getTable(TercerosPeer::TABLE_NAME);

			if (! is_array($cols)) {
				$cols = array($cols);
			}

			foreach($cols as $colName) {
				if ($tableMap->containsColumn($colName)) {
					$get = 'get' . $tableMap->getColumn($colName)->getPhpName();
					$columns[$colName] = $obj->$get();
				}
			}
		} else {

		}

		$res =  BasePeer::doValidate(TercerosPeer::DATABASE_NAME, TercerosPeer::TABLE_NAME, $columns);
    if ($res !== true) {
        $request = sfContext::getInstance()->getRequest();
        foreach ($res as $failed) {
            $col = TercerosPeer::translateFieldname($failed->getColumn(), BasePeer::TYPE_COLNAME, BasePeer::TYPE_PHPNAME);
            $request->setError($col, $failed->getMessage());
        }
    }

    return $res;
	}

	
	public static function retrieveByPK($pk, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$criteria = new Criteria(TercerosPeer::DATABASE_NAME);

		$criteria->add(TercerosPeer::NITOCC, $pk);


		$v = TercerosPeer::doSelect($criteria, $con);

		return !empty($v) > 0 ? $v[0] : null;
	}

	
	public static function retrieveByPKs($pks, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$objs = null;
		if (empty($pks)) {
			$objs = array();
		} else {
			$criteria = new Criteria();
			$criteria->add(TercerosPeer::NITOCC, $pks, Criteria::IN);
			$objs = TercerosPeer::doSelect($criteria, $con);
		}
		return $objs;
	}

} 
if (Propel::isInit()) {
			try {
		BaseTercerosPeer::getMapBuilder();
	} catch (Exception $e) {
		Propel::log('Could not initialize Peer: ' . $e->getMessage(), Propel::LOG_ERR);
	}
} else {
			Propel::registerMapBuilder('lib.model.map.TercerosMapBuilder');
}
